﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;

namespace PristaniNaMesici
{
    public class Module
    {
        private int id;
        private double x;
        private double y;
        private double vx;
        private double vy;
        private double fuel;
        private double targetX;
        private double targetY;
        private byte left;
        private byte right;
        private byte up;

        private System.Windows.Controls.Image image;

        public int ID
        {
            get { return id; }
        }

        public double X
        {
            get { return x; }
        }

        public double Y
        {
            get { return y; }
        }

        public double Vx
        {
            get { return vx; }
        }

        public double Vy
        {
            get { return vy; }
        }

        public double Fuel
        {
            get { return fuel; }
        }

        public double TargetX
        {
            get { return targetX; }
        }

        public double TargetY
        {
            get { return targetY; }
        }

        public byte Left
        {
            get { return left; }
            set { left = value; }
        }

        public byte Right
        {
            get { return right; }
            set { right = value; }
        }

        public byte Up
        {
            get { return up; }
            set { up = value; }
        }

        public System.Windows.Controls.Image Image
        {
            get { return image; }
        }

        public Module(int id, double x, double y, double vx, double vy, double targetX, double targetY)
        {
            this.id = id;
            this.x = x;
            this.y = y;
            this.vx = vx;
            this.vy = vy;
            this.fuel = 20;
            this.targetX = targetX;
            this.targetY = targetY;

            left = 0;
            right = 0;
            up = 0;

            image = new System.Windows.Controls.Image();
            image.Source = new System.Windows.Media.Imaging.BitmapImage(new Uri("Images/lunar_lander.png", UriKind.Relative));
            image.HorizontalAlignment = HorizontalAlignment.Center;
            image.VerticalAlignment = VerticalAlignment.Center;
            image.Width = 20;
            image.Height = 20;
            
        }

        public static Module FromFile(string fileName)
        {
            return null;
        }

        public static Module FromString(string content)
        {
            string[] lines = Regex.Split(content, "\r\n|\r|\n");

            int id = int.Parse(lines[0]);
            double x = double.Parse(lines[1].Split(' ')[0], CultureInfo.InvariantCulture);
            double y = double.Parse(lines[1].Split(' ')[1], CultureInfo.InvariantCulture);
            double vx = double.Parse(lines[2].Split(' ')[0], CultureInfo.InvariantCulture);
            double vy = double.Parse(lines[2].Split(' ')[1], CultureInfo.InvariantCulture);
            double targetx = double.Parse(lines[4].Split(' ')[0], CultureInfo.InvariantCulture);
            double targety = double.Parse(lines[4].Split(' ')[1], CultureInfo.InvariantCulture);

            return new Module(id, x, y, vx, vy, targetx, targety);
        }

        public void SetFromString(string content)
        {
            string[] lines = Regex.Split(content, "\r\n|\r|\n");

            id = int.Parse(lines[0]);
            x = double.Parse(lines[1].Split(' ')[0], CultureInfo.InvariantCulture);
            y = double.Parse(lines[1].Split(' ')[1], CultureInfo.InvariantCulture);
            vx = double.Parse(lines[2].Split(' ')[0], CultureInfo.InvariantCulture);
            vy = double.Parse(lines[2].Split(' ')[1], CultureInfo.InvariantCulture);
            targetX = double.Parse(lines[4].Split(' ')[0], CultureInfo.InvariantCulture);
            targetY = double.Parse(lines[4].Split(' ')[1], CultureInfo.InvariantCulture);
        }

        public void Update(double time)
        {
            /*x = x + vx * time + 0.5 * (6 * right - 6 * left) * time * time;
            y = y - vy * (time) + 0.5 * (-7 + 12 * up) * time * time;

            vx = vx + (6 * right - 6 * left) * time;
            vy = vy + (-7 + 12 * up) * time;*/

            if (fuel > 0)
                fuel = fuel - (0.5 * left + 0.5 * right + 1 * up) * time;
            else
                fuel = 0;

            Application.Current.Dispatcher.Invoke(() =>
            {
                Canvas.SetLeft(image, x);
                Canvas.SetTop(image, y);
            });

            if (MainWindow.IsKeyPressed(Key.Left) && fuel > 0)
                left = 1;
            else
                left = 0;

            if (MainWindow.IsKeyPressed(Key.Right) && fuel > 0)
                right = 1;
            else
                right = 0;

            if (MainWindow.IsKeyPressed(Key.Up) && fuel > 0)
                up = 1;
            else
                up = 0;

            Server.SendDirection(this);

            string[] lines = Regex.Split(Server.GetState(this), "\r\n|\r|\n");

            try {
                x = double.Parse(lines[1].Split(' ')[0], CultureInfo.InvariantCulture);
                y = double.Parse(lines[1].Split(' ')[1], CultureInfo.InvariantCulture);
            }
            catch
            {
                MessageBox.Show(lines[0]);
                MainWindow.running = false;
                MainWindow.watch.Reset();
            }
        }
    }
}
